//===================================CISCKER====================================
//==================================Mult/Div===================================
//------------------------------------------------------------------------------
//File Name:	multiplier_divider.v
//Purpose:		Sequential multiplier and divider module
//Parameters:	width of data
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------


module multiplier_divider #(parameter width=8)(
	input [width-1:0]acca,
	input [width-1:0]accb,
	input [width-1:0]hidden,
	input mult_div,
	output [width-1:0]acca_result,
	output [width-1:0]accb_result);
		
wire [width-1:0] x = mult_div ? acca : {acca[width-2:0],accb[width-1]};
wire Cout;
wire [width-1:0] y;
assign {Cout,y} = mult_div ? (x+hidden) : (x-hidden);


wire [width:0]mult_result	= accb[0] ? {Cout,y[width-1:0]} : {1'b0,acca[width-1:0]};
wire [width-1:0]div_result	= y[width-1] ? {acca[width-2:0],accb[width-1]}	: y;

assign acca_result = mult_div ?   mult_result[width:1] : div_result;

assign accb_result = mult_div ? {mult_result[0],accb[width-1:1]} : {accb[width-2:0],!y[width-1]};

endmodule 