//===================================CISCKER====================================
//===================================Phaser=====================================
//------------------------------------------------------------------------------
//File Name:	phaser.v
//Purpose:		Create phased clocks
//Parameters:	None
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------
module phaser( 
	input clk_in,
	input reset,
	output reg clk_270=1,
	output reg clk_180=0,
	output reg clk_90=0,
	output reg clk_0=1
   );
	
always @ (posedge clk_in or posedge reset)
	if(reset)
		begin
			clk_270 <= 1;
			clk_90	<= 0;
		end
	else
		begin
			clk_270 <= clk_180;
			clk_90	<= clk_0;
		end
	
always @ (negedge clk_in or posedge reset)
	if(reset)
		begin
			clk_180 <= 0;
			clk_0	<= 1;
		end
	else
		begin
			clk_180 <= clk_90;
			clk_0 	<= clk_270;
		end

endmodule 